/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


//=====
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#ifndef __bbstdReadVectorFromFile_h_INCLUDED__
#define __bbstdReadVectorFromFile_h_INCLUDED__
#include "bbstd_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"


namespace bbstd
{

class bbstd_EXPORT ReadVectorFromFile
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(ReadVectorFromFile,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
	BBTK_DECLARE_INPUT(FileName,std::string);
	BBTK_DECLARE_OUTPUT(Out,std::vector <std::vector<double> >);
	BBTK_DECLARE_INPUT(LineLength,int);	
	BBTK_PROCESS(Process);
  void Process();
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(ReadVectorFromFile,bbtk::AtomicBlackBox);
	BBTK_NAME("ReadVectorFromFile");
	BBTK_AUTHOR("jpr");
	BBTK_DESCRIPTION("Read any Vector from a text file");
	BBTK_CATEGORY("read/write");
	BBTK_INPUT(ReadVectorFromFile,FileName,"3D Points file name",std::string,"");
	BBTK_INPUT(ReadVectorFromFile,LineLength,"(default 1) - The number of columns of the file",int,"");	
	BBTK_OUTPUT(ReadVectorFromFile,Out,"vector of data",std::vector< std::vector <double> >,"");

BBTK_END_DESCRIBE_BLACK_BOX(ReadVectorFromFile);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 

}
// EO namespace bbstd

#endif // __bbstdReadVectorFromFile_h_INCLUDED__

