/*
 # ---------------------------------------------------------------------
 #
 # Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image
 #                        pour la SantÈ)
 # Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
 # Previous Authors : Laurent Guigues, Jean-Pierre Roux
 # CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
 #
 #  This software is governed by the CeCILL-B license under French law and
 #  abiding by the rules of distribution of free software. You can  use,
 #  modify and/ or redistribute the software under the terms of the CeCILL-B
 #  license as circulated by CEA, CNRS and INRIA at the following URL
 #  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
 #  or in the file LICENSE.txt.
 #
 #  As a counterpart to the access to the source code and  rights to copy,
 #  modify and redistribute granted by the license, users are provided only
 #  with a limited warranty  and the software's author,  the holder of the
 #  economic rights,  and the successive licensors  have only  limited
 #  liability.
 #
 #  The fact that you are presently reading this means that you have had
 #  knowledge of the CeCILL-B license and that you accept its terms.
 # ------------------------------------------------------------------------ */


#ifndef __bbvtkSliceImage_h_INCLUDED__
#define __bbvtkSliceImage_h_INCLUDED__
#include "bbvtk_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include "vtkImageCast.h"
#include <vtkType.h>
#include <vtkImageData.h>

namespace bbvtk
{

class bbvtk_EXPORT SliceImage
 :
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(SliceImage,bbtk::AtomicBlackBox);
  BBTK_DECLARE_INPUT(In,vtkImageData*);
  BBTK_DECLARE_INPUT(Z,int);
  BBTK_DECLARE_OUTPUT(Out,vtkImageData *);
  BBTK_DECLARE_OUTPUT(Max,int);
  BBTK_PROCESS(Process);
  void Process();

  int lastId;

  vtkImageData* final;

  vtkImageCast* caster;
};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(SliceImage,bbtk::AtomicBlackBox);
BBTK_NAME("SliceImage");
BBTK_AUTHOR("_author_");
BBTK_DESCRIPTION("_description_");
BBTK_CATEGORY("__CATEGORY__");
BBTK_INPUT(SliceImage,In,"3D Image",vtkImageData*,"");
BBTK_INPUT(SliceImage,Z,"shoice",int,"");
BBTK_OUTPUT(SliceImage,Out,"2D Slice",vtkImageData*,"");
BBTK_OUTPUT(SliceImage,Max,"Maximum",int,"");
BBTK_END_DESCRIBE_BLACK_BOX(SliceImage);
}
// EO namespace bbvtk

#endif // __bbvtkSliceImage_h_INCLUDED__

